from plop_py import *

class PLOP(object):

    def __init__(self):
        self.__p = PLOP_new()
        PLOP_set_option(self.__p, "objorient=true")

    # it is recommended not to use __del__ as it is not guaranteed
    # when this will be executed (see Python Esential Reference Page 94).
    # so we also implement a delete method and invalidate self.__p
    # whenever this will be called.
    def __del__(self):
        if (self.__p):
            PLOP_delete(self.__p)

    def delete(self):
        if (self.__p):
            PLOP_delete(self.__p)
        self.__p = 0

    def close_document(self, doc, optlist):
        PLOP_close_document(self.__p, doc, optlist)

    def convert_to_unicode(self, inputformat, inputstring, optlist):
        return PLOP_convert_to_unicode(self.__p, inputformat, inputstring, optlist)

    def create_document(self, filename, optlist):
        return PLOP_create_document(self.__p, filename, optlist)

    def create_pvf(self, filename, data, optlist):
        PLOP_create_pvf(self.__p, filename, data, optlist)

    def delete_pvf(self, filename):
        return PLOP_delete_pvf(self.__p, filename)

    def get_apiname(self):
        return PLOP_get_apiname(self.__p)

    def get_buffer(self):
        return PLOP_get_buffer(self.__p)

    def get_errmsg(self):
        return PLOP_get_errmsg(self.__p)

    def get_errnum(self):
        return PLOP_get_errnum(self.__p)

    def info_pvf(self, filename, keyword):
        return PLOP_info_pvf(self.__p, filename, keyword)

    def open_document(self, filename, optlist):
        return PLOP_open_document(self.__p, filename, optlist)

    def pcos_get_number(self, doc, path):
        return PLOP_pcos_get_number(self.__p, doc, path)

    def pcos_get_stream(self, doc, optlist, path):
        return PLOP_pcos_get_stream(self.__p, doc, optlist, path)

    def pcos_get_string(self, doc, path):
        return PLOP_pcos_get_string(self.__p, doc, path)

    def prepare_signature(self, optlist):
        return PLOP_prepare_signature(self.__p, optlist)

    def set_option(self, optlist):
        PLOP_set_option(self.__p, optlist)

